﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.ultraGridExcelExporter1.Export(this.ultraGrid1, "test.xls");
            Process.Start("test.xls");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet ds = new DataSet();
            DataTable parentTable = ds.Tables.Add("Parent");
            DataTable childTable = ds.Tables.Add("Child");
            DataTable grandChildTable = ds.Tables.Add("GrandChild");


            parentTable.Columns.Add("Text1");
            parentTable.Columns.Add("Text2");
            parentTable.Columns.Add("Text3");
            parentTable.Columns.Add("Text4");
            parentTable.Columns.Add("Text5");
            parentTable.Columns.Add("ID", typeof(int));

            parentTable.Rows.Add("Text1", "Text2", "Text3", "Text4", "Text5", 0);
            parentTable.Rows.Add("Text1", "Text2", "Text3", "Text4", "Text5", 1);
            parentTable.Rows.Add("Text1", "Text2", "Text3", "Text4", "Text5", 2);
            parentTable.Rows.Add("Text1", "Text2", "Text3", "Text4", "Text5", 3);
            parentTable.Rows.Add("Text1", "Text2", "Text3", "Text4", "Text5", 4);
            parentTable.Rows.Add("Text1", "Text2", "Text3", "Text4", "Text5", 5);
            parentTable.Rows.Add("Text1", "Text2", "Text3", "Text4", "Text5", 6);
            parentTable.Rows.Add("Text1", "Text2", "Text3", "Text4", "Text5", 7);

            childTable.Columns.Add("ChildText2");
            childTable.Columns.Add("ChildText3");
            childTable.Columns.Add("ChildText4");
            childTable.Columns.Add("ChildText5");
            childTable.Columns.Add("ID", typeof(int));
            childTable.Columns.Add("ParentID", typeof(int));



            childTable.Rows.Add("Text2", "Text3", "Text4", "Text5", 0, 0);
            childTable.Rows.Add("Text2", "Text3", "Text4", "Text5", 1, 0);
            childTable.Rows.Add("Text2", "Text3", "Text4", "Text5", 2, 1);
            childTable.Rows.Add("Text2", "Text3", "Text4", "Text5", 3, 1);
            childTable.Rows.Add("Text2", "Text3", "Text4", "Text5", 4, 2);
            childTable.Rows.Add("Text2", "Text3", "Text4", "Text5", 5, 2);
            childTable.Rows.Add("Text2", "Text3", "Text4", "Text5", 6, 3);
            childTable.Rows.Add("Text2", "Text3", "Text4", "Text5", 7, 3);

            grandChildTable.Columns.Add("GrandChildText3");
            grandChildTable.Columns.Add("GrandChildText4");
            grandChildTable.Columns.Add("GrandChildText5");
            grandChildTable.Columns.Add("ID", typeof(int));
            grandChildTable.Columns.Add("ParentID", typeof(int));


            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 0, 0);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 1, 0);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 2, 1);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 3, 1);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 4, 2);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 5, 2);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 6, 3);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 7, 3);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 8, 4);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 9, 4);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 10, 5);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 11, 5);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 12, 6);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 13, 6);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 14, 7);
            grandChildTable.Rows.Add("Text3", "Text4", "Text5", 15, 7);

            ds.Relations.Add(
                new DataRelation("r1", parentTable.Columns["ID"], childTable.Columns["ParentID"]));
            ds.Relations.Add(
                new DataRelation("r2", childTable.Columns["ID"], grandChildTable.Columns["ParentID"]));

            this.ultraGrid1.DataSource = ds;
            this.ultraGrid1.DataMember = "Parent";

            this.ultraGridExcelExporter1.HeaderRowExporting += new Infragistics.Win.UltraWinGrid.ExcelExport.HeaderRowExportingEventHandler(ultraGridExcelExporter1_HeaderRowExporting);
            this.ultraGridExcelExporter1.RowExported += new Infragistics.Win.UltraWinGrid.ExcelExport.RowExportedEventHandler(ultraGridExcelExporter1_RowExported);
            this.ultraGridExcelExporter1.ExportStarted += new Infragistics.Win.UltraWinGrid.ExcelExport.ExportStartedEventHandler(ultraGridExcelExporter1_ExportStarted);
            this.ultraGridExcelExporter1.ExportEnded += new Infragistics.Win.UltraWinGrid.ExcelExport.ExportEndedEventHandler(ultraGridExcelExporter1_ExportEnded);
        }

        void ultraGridExcelExporter1_ExportEnded(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.ExportEndedEventArgs e)
        {
        }

        void ultraGridExcelExporter1_ExportStarted(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.ExportStartedEventArgs e)
        {
        }

        void ultraGridExcelExporter1_RowExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.RowExportedEventArgs e)
        {
            e.CurrentWorksheet.Rows[e.CurrentRowIndex - 1].Hidden = false;
        }

        void ultraGridExcelExporter1_HeaderRowExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.HeaderRowExportingEventArgs e)
        {
            if (e.Band.Key == "r1")
            {
                e.Cancel = true;
                e.CurrentRowIndex--;
            }
            else if (e.Band.Key == "r2")
            {
                e.Cancel = true;
                e.CurrentRowIndex--;
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            foreach (UltraGridBand band in e.Layout.Bands)
            {
                if (band.Index > 0)
                {
                    band.Indentation = -1;
                    //band.IndentationGroupByRow = -1;
                    //band.IndentationGroupByRowExpansionIndicator = -1;
                }

                if (band.Columns.IndexOf("ID") != -1)
                    band.Columns["ID"].Hidden = true;
                if (band.Columns.IndexOf("ParentID") != -1)
                    band.Columns["ParentID"].Hidden = true;

            }
        }
    }
}
